import { FactoryProvider, Type } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export declare type ProvideValueAccessorFieldSelector<C extends object> = ((component: C) => ControlValueAccessor) | {
    [K in keyof C]: C[K] extends ControlValueAccessor ? K : never;
}[keyof C];
export declare function provideValueAccessor(fn: () => Type<ControlValueAccessor>): FactoryProvider;
export declare function provideValueAccessor<C extends object>(fn: () => Type<C>, fieldSelector: ProvideValueAccessorFieldSelector<C>): FactoryProvider;
